#include <malloc.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>

// define UPLOAD for W3D Shareware version
//#define SPEAR
//#define SPEARDEMO
#define UPLOAD

#ifndef SPEAR

#ifndef UPLOAD
#define EXTENSION "wl6"
#else
#define EXTENSION "wl1"
#endif

//
// Base offsets
//
#define STARTPCSOUNDS		0
#define STARTADLIBSOUNDS	87
#define STARTMUSIC		    261

#define LASTMUSIC           27

#else /* SPEAR */

#ifndef SPEARDEMO
#define EXTENSION "sod"
#else /* SPEARDEMO */
#define EXTENSION "sdm"
#endif /* SPEARDEMO */

/* Base offsets */
#define STARTPCSOUNDS		0
#define STARTADLIBSOUNDS	81
#define STARTMUSIC		    243

#define LASTMUSIC           24

#endif /* SPEAR */


#ifndef O_BINARY
#define O_BINARY 0
#endif

typedef unsigned char byte;
typedef unsigned short word;
typedef byte * memptr;

static void process_music(void);

int main(void)
{
    process_music();

    return 0;
}

int OpenWrite(char *fn)
{
	int fp;

	fp = open(fn, O_CREAT|O_WRONLY|O_TRUNC|O_BINARY, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH);
	return fp;
}

void CloseWrite(int fp)
{
	close(fp);
}

int WriteBytes(int fp, byte *d, int len)
{
	return write(fp, d, len);
}

int OpenRead(char *fn)
{
	int fp;

	fp = open(fn, O_RDONLY | O_BINARY);

	return fp;
}

void CloseRead(int fp)
{
	close(fp);
}

int ReadSeek(int fp, int offset, int whence)
{
	return lseek(fp, offset, whence);
}

int16_t ReadInt16(int fp)
{
	byte d[2];

	read(fp, d, 2);

	return (d[0]) | (d[1] << 8);
}

int32_t ReadInt32(int fp)
{
	byte d[4];

	read(fp, d, 4);

	return (d[3]) | (d[2] << 8) | (d[1] << 16) | (d[0] << 24);
}

int ReadBytes(int fp, byte *d, int len)
{
	return read(fp, d, len);
}

static void process_music(void)
{
    int ihandle, ahandle, ohandle;
	long pos;
	char iname[80];
	char aname[80];
	char oname[80];
	int i, length;
	byte *buffer = NULL;

	strcpy(iname, "romfiles/audiohed.");
	strcat(iname, EXTENSION);
	strcpy(aname, "romfiles/audiot.");
	strcat(aname, EXTENSION);

	ihandle = OpenRead(iname);
	if (ihandle == -1) {
	    printf("Couldn't open %s to read\n", iname);
	    return;
    }
	ahandle = OpenRead(aname);
	if (ahandle == -1) {
	    printf("Couldn't open %s to read\n", aname);
	    CloseRead(ihandle);
	    return;
    }

    for (i=0; i<LASTMUSIC; i++) {
       	ReadSeek(ihandle, i*4 + STARTMUSIC*4, SEEK_SET);
        pos = ReadInt32(ihandle);
        printf("Music %d at %x\n", i, pos);
       	ReadSeek(ahandle, pos, SEEK_SET);
       	length = ReadInt16(ahandle);
       	if (length == 0)
       	    continue;
        printf("Music %d is %d bytes long\n", i, length);
        if (buffer)
            free(buffer);
        buffer = malloc(length+2);
        buffer[0] = length & 255;
        buffer[1] = length >> 8;
        ReadBytes(ahandle, &buffer[2], length);

    	sprintf(oname, "music_%d.imf", i);

        ohandle = OpenWrite(oname);
	    if (ohandle == -1) {
	        printf("Couldn't open %s to write\n", oname);
	        CloseRead(ihandle);
	        continue;
        }
        WriteBytes(ohandle, buffer, length+2);
        CloseWrite(ohandle);
    }
    if (buffer)
        free(buffer);

    CloseRead(ihandle);
    CloseRead(ahandle);
}
